"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tsioc_1 = require("tsioc");
var index_1 = require("../util/index");
var AnnotationLogerAspect = /** @class */ (function () {
    function AnnotationLogerAspect(container, config) {
        this.container = container;
        this.config = config;
        this.logManger = this.container.resolve(config.logLib || 'console');
        this.logManger.configure(config.logConfig);
        this.logger = this.logManger.getLogger();
    }
    AnnotationLogerAspect.prototype.log = function (joinPoint, annotation) {
        var _this = this;
        if (annotation && annotation.length) {
            annotation.forEach(function (logmeta) {
                var canlog = false;
                if (logmeta.express && logmeta.express(joinPoint)) {
                    canlog = true;
                }
                else if (!logmeta.express) {
                    canlog = true;
                }
                if (canlog) {
                    _this.dolog(logmeta.logname ? _this.logManger.getLogger(logmeta.logname) : _this.logger, joinPoint);
                }
            });
        }
        else {
            this.dolog(this.logger, joinPoint);
        }
    };
    AnnotationLogerAspect.prototype.dolog = function (logger, joinPoint) {
        switch (joinPoint.state) {
            case tsioc_1.JoinpointState.Before:
            case tsioc_1.JoinpointState.After:
            case tsioc_1.JoinpointState.AfterReturning:
                this.logger.info(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
            case tsioc_1.JoinpointState.Pointcut:
                this.logger.info(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
            case tsioc_1.JoinpointState.AfterThrowing:
                this.logger.error(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
        }
    };
    __decorate([
        tsioc_1.Pointcut('@annotation(Logger)', 'annotation'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [tsioc_1.Joinpoint, Array]),
        __metadata("design:returntype", void 0)
    ], AnnotationLogerAspect.prototype, "log", null);
    AnnotationLogerAspect = __decorate([
        tsioc_1.Singleton,
        tsioc_1.Aspect,
        __param(0, tsioc_1.Inject(tsioc_1.symbols.IContainer)), __param(1, tsioc_1.Inject(index_1.mvcSymbols.IConfiguration)),
        __metadata("design:paramtypes", [Object, Object])
    ], AnnotationLogerAspect);
    return AnnotationLogerAspect;
}());
exports.AnnotationLogerAspect = AnnotationLogerAspect;

//# sourceMappingURL=../sourcemaps/aop/AnnotationLogerAspect.js.map
