"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tsioc_1 = require("tsioc");
var index_1 = require("../index");
var DebugAspect = /** @class */ (function () {
    function DebugAspect(container, config) {
        this.container = container;
        this.config = config;
        var logManger = this.container.resolve(config.logLib || 'console');
        logManger.configure(config.logConfig);
        this.logger = logManger.getLogger();
    }
    DebugAspect.prototype.log = function (joinPoint) {
        switch (joinPoint.state) {
            case tsioc_1.JoinpointState.Before:
            case tsioc_1.JoinpointState.After:
            case tsioc_1.JoinpointState.AfterReturning:
                this.logger.debug(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
            case tsioc_1.JoinpointState.Pointcut:
                this.logger.info(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
            case tsioc_1.JoinpointState.AfterThrowing:
                this.logger.error(this.config.logFormat, joinPoint.fullName, joinPoint.state, joinPoint.args, joinPoint.returning, joinPoint.throwing);
                break;
        }
    };
    __decorate([
        tsioc_1.Around('execution(*.*)'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [tsioc_1.Joinpoint]),
        __metadata("design:returntype", void 0)
    ], DebugAspect.prototype, "log", null);
    DebugAspect = __decorate([
        tsioc_1.Singleton,
        tsioc_1.Aspect,
        __param(0, tsioc_1.Inject(tsioc_1.symbols.IContainer)), __param(1, tsioc_1.Inject(index_1.mvcSymbols.IConfiguration)),
        __metadata("design:paramtypes", [Object, Object])
    ], DebugAspect);
    return DebugAspect;
}());
exports.DebugAspect = DebugAspect;

//# sourceMappingURL=../sourcemaps/aop/DebugAspect.js.map
