"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./RequestMethod"));
__export(require("./decorators"));
__export(require("./middlewares"));
__export(require("./results"));
__export(require("./router"));
__export(require("./Application"));
__export(require("./BaseController"));
var middlewares_1 = require("./middlewares");
var tsioc_1 = require("tsioc");
var index_1 = require("../util/index");
var router_1 = require("./router");
var BaseController_1 = require("./BaseController");
var decorators_1 = require("./decorators");
function registerDefaults(container) {
    var lifeScope = container.getLifeScope();
    lifeScope.registerDecorator(decorators_1.Controller, tsioc_1.CoreActions.bindProvider);
    lifeScope.registerDecorator(decorators_1.Authorization, tsioc_1.CoreActions.bindProvider);
    lifeScope.registerDecorator(decorators_1.Middleware, tsioc_1.CoreActions.bindProvider);
    lifeScope.registerDecorator(decorators_1.Model, tsioc_1.CoreActions.bindProvider);
    container.register(router_1.ModelParser);
    container.register(BaseController_1.BaseController);
}
exports.registerDefaults = registerDefaults;
function registerDefaultMiddlewars(container) {
    container.register(index_1.mvcSymbols.ContentMiddleware, middlewares_1.DefaultContentMiddleware);
    container.register(index_1.mvcSymbols.ContextMiddleware, middlewares_1.DefaultContextMiddleware);
    container.register(index_1.mvcSymbols.JsonMiddleware, middlewares_1.DefaultJsonMiddleware);
    container.register(index_1.mvcSymbols.LogMiddleware, middlewares_1.DefaultLogMiddleware);
    container.register(index_1.mvcSymbols.SessionMiddleware, middlewares_1.DefaultSessionMiddleware);
    container.register(index_1.mvcSymbols.BodyParserMiddleware, middlewares_1.DefaultBodyParserMiddleware);
    container.register(index_1.mvcSymbols.ViewsMiddleware, middlewares_1.DefaultViewsMiddleware);
    container.register(index_1.mvcSymbols.CorsMiddleware, middlewares_1.DefaultCorsMiddleware);
    container.register(router_1.Router);
}
exports.registerDefaultMiddlewars = registerDefaultMiddlewars;

//# sourceMappingURL=../sourcemaps/core/index.js.map
