"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tsioc_1 = require("tsioc");
var NotFoundRoute_1 = require("./NotFoundRoute");
/**
 * base route.
 *
 * @export
 * @class BaseRoute
 * @extends {Composite}
 * @implements {IRoute}
 */
var BaseRoute = /** @class */ (function (_super) {
    __extends(BaseRoute, _super);
    function BaseRoute(route) {
        var _this = _super.call(this, route) || this;
        _this.url = route.substring(0);
        return _this;
    }
    BaseRoute.prototype.add = function (node) {
        var baseUrl = this.cutEmptyPath(this.url, true);
        node.url = baseUrl + node.url;
        _super.prototype.add.call(this, node);
        return this;
    };
    BaseRoute.prototype.cutEmptyPath = function (routPath, foreNull) {
        if (foreNull === void 0) { foreNull = false; }
        if (foreNull && routPath === '/') {
            return '';
        }
        if (/\/\s*$/.test(routPath)) {
            routPath = routPath.substring(0, routPath.lastIndexOf('/'));
        }
        if (/\?\S*$/.test(routPath)) {
            routPath = routPath.substring(0, routPath.lastIndexOf('?'));
        }
        return routPath;
    };
    BaseRoute.prototype.match = function (ctx) {
        var prefix = tsioc_1.isString(ctx) ? ctx : ctx.url;
        var route = this.find(function (r) {
            return r.url && prefix && prefix.indexOf(r.url) === 0;
        }, tsioc_1.Mode.traverseLast);
        return route;
    };
    BaseRoute.prototype.empty = function () {
        return NotFoundRoute_1.notFoundRoute;
    };
    return BaseRoute;
}(tsioc_1.Composite));
exports.BaseRoute = BaseRoute;

//# sourceMappingURL=../../sourcemaps/core/router/BaseRoute.js.map
