import { BaseRoute } from './BaseRoute';
import { Type, IContainer, IParameter, Providers } from 'tsioc';
import { IContext } from '../IContext';
import { Next } from '../../util';
import { CorsMetadata, RouteMetadata } from '../metadata';
import { RequestMethod } from '../RequestMethod';
export declare class ControllerRoute extends BaseRoute {
    private controller;
    constructor(route: string, controller: Type<any>);
    options(container: IContainer, ctx: IContext, next: Next): Promise<any>;
    navigating(container: IContainer, ctx: IContext, next: Next): Promise<any>;
    invokeOption(ctx: IContext, container: IContainer, next: Next): Promise<any>;
    getCorsMeta(ctx: IContext, container: IContainer, reqMethod: string): CorsMetadata;
    invoke(ctx: IContext, container: IContainer): Promise<void>;
    protected createProvider(container: IContainer, ctx: IContext, ctrl: any, meta: RouteMetadata, params: IParameter[]): Providers[];
    protected isRestUri(uri: string): boolean;
    protected getRouteMetaData(ctx: IContext, container: IContainer, requestMethod: RequestMethod): RouteMetadata;
}
