"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Application_1 = require("../Application");
var Configuration_1 = require("../../Configuration");
var decorators_1 = require("../decorators");
var RootRoute_1 = require("./RootRoute");
var RouteBuilder_1 = require("./RouteBuilder");
var util_1 = require("../../util");
var compose = require('koa-compose');
var Router = /** @class */ (function () {
    function Router(builder, app, config) {
        this.builder = builder;
        this.app = app;
        this.config = config;
        this.root = new RootRoute_1.RootRoute(config.routePrefix);
    }
    Router.prototype.routes = function (map) {
        this.root.add(map);
    };
    Router.prototype.register = function () {
        var controllers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            controllers[_i] = arguments[_i];
        }
        (_a = this.builder).build.apply(_a, [this].concat(controllers));
        var _a;
    };
    Router.prototype.setup = function () {
        var _this = this;
        this.app.use(function (ctx, next) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if ((!ctx.status || ctx.status === 404) && this.config.isRouteUrl(ctx.url)) {
                    return [2 /*return*/, this.root.navigating(this.app.container, ctx, next)];
                }
                return [2 /*return*/];
            });
        }); });
        // let stack = [];
        // stack.push(async (ctx, next) => {
        //     if (!ctx.status || ctx.status === 404) {
        //         return this.root.options(this.app.container, ctx, next);
        //     }
        // });
        // stack.push(async (ctx, next) => {
        //     if (!ctx.status || ctx.status === 404) {
        //         return this.root.navigating(this.app.container, ctx, next);
        //     }
        // })
        // this.app.use(compose(stack));
    };
    Router.prototype.getRoot = function () {
        return this.root;
    };
    Router = __decorate([
        decorators_1.Middleware(util_1.mvcSymbols.RouterMiddleware),
        __metadata("design:paramtypes", [RouteBuilder_1.RouteBuilder, Application_1.Application, Configuration_1.Configuration])
    ], Router);
    return Router;
}());
exports.Router = Router;

//# sourceMappingURL=../../sourcemaps/core/router/Router.js.map
